/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char *
output_1 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 246 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  switch (which_alternative)
    {
    case 0:
      return "";
    case 1:
    case 2:
    case 5:
    case 6:
      return "mov %1,%0";
    case 3:
    case 4:
      return "movbu %1,%0";
    default:
      gcc_unreachable ();
    }
}
}

static const char *
output_2 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 294 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  switch (which_alternative)
    {
    case 0:
      return "";
    case 1:
      /* Note that "MOV imm8,An" is already zero-extending, and is 2 bytes.
	 We have "MOV imm16,Dn" at 3 bytes.  The only win for the 4 byte
	 movu is for an 8-bit unsigned move into Rn.  */
      if (TARGET_AM33
	  && CONST_INT_P (operands[1])
	  && IN_RANGE (INTVAL (operands[1]), 0x80, 0xff)
	  && REGNO_EXTENDED_P (REGNO (operands[0]), 1))
	return "movu %1,%0";
      /* FALLTHRU */
    case 5:
    case 6:
    case 2:
      return "mov %1,%0";
    case 3:
    case 4:
      return "movhu %1,%0";
    default:
      gcc_unreachable ();
    }
}
}

static const char *
output_3 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 437 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  switch (which_alternative)
    {
    case 0:
      return "";
    case 1: /* imm-reg.  */
    case 2: 
      /* See movhi for a discussion of sizes for 8-bit movu.  Note that the
	 24-bit movu is 6 bytes, which is the same size as the full 32-bit
	 mov form for An and Dn.  So again movu is only a win for Rn.  */
      if (TARGET_AM33
	  && CONST_INT_P (operands[1])
	  && REGNO_EXTENDED_P (REGNO (operands[0]), 1))
	{
	  HOST_WIDE_INT val = INTVAL (operands[1]);
	  if (IN_RANGE (val, 0x80, 0xff)
	      || IN_RANGE (val, 0x800000, 0xffffff))
	    return "movu %1,%0";
	}
      /* FALLTHRU */
    case 3:  /* reg-reg */
    case 4:  /* reg-mem */
    case 5:  /* mem-reg */
    case 6:  /* sp-reg */
    case 7:  /* reg-sp */
    case 8:  /* imm-sp */
    case 9:  /* reg-mdr */
    case 10:  /* mdr-reg */
      return "mov %1,%0";
    default:
      gcc_unreachable ();
    }
}
}

static const char *
output_4 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 509 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  switch (which_alternative)
    {
    case 0:
      return "";
    case 1:
    case 3:
    case 7:
    case 8:
    case 11:
    case 12:
      return "mov %1,%0";
    case 2:
    case 4:
    case 5:
    case 6:
    case 9:
    case 10:
      return "fmov %1,%0";
    default:
      gcc_unreachable ();
    }
}
}

static const char *
output_8 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 587 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{ return mn10300_output_add (operands, false); }
}

static const char *
output_9 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 602 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{ return mn10300_output_add (operands, true); }
}

static const char * const output_10[] = {
  "addc %2,%0",
  "addc %2,%0",
  "addc %2,%1,%0",
};

static const char * const output_13[] = {
  "sub %2,%0",
  "sub %2,%0",
  "sub %2,%0",
  "sub %2,%1,%0",
};

static const char * const output_14[] = {
  "sub %2,%0",
  "sub %2,%1,%0",
};

static const char * const output_15[] = {
  "subc %2,%0",
  "subc %2,%0",
  "subc %2,%1,%0",
};

static const char *
output_19 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1029 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  if (which_alternative == 1)
    return "mul %2,%3,%1,%0";
  else if (TARGET_MULT_BUG)
    return "nop\n\tnop\n\tmul %3,%0";
  else
    return "mul %3,%0";
}
}

static const char *
output_20 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1067 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  if (which_alternative == 1)
    return "mulu %2,%3,%1,%0";
  else if (TARGET_MULT_BUG)
    return "nop\n\tnop\n\tmulu %3,%0";
  else
    return "mulu %3,%0";
}
}

static const char *
output_21 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1096 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  if (which_alternative == 2)
    return "mul %2,%3,%1,%0";
  else if (TARGET_MULT_BUG)
    return "nop\n\tnop\n\tmul %3,%0";
  else
    return "mul %3,%0";
}
}

static const char * const output_25[] = {
  "and %2,%0",
  "and %2,%0",
  "and %2,%1,%0",
};

static const char * const output_26[] = {
  "and %2,%0",
  "and %2,%0",
  "and %2,%1,%0",
};

static const char * const output_27[] = {
  "or %2,%0",
  "or %2,%0",
  "or %2,%1,%0",
};

static const char * const output_28[] = {
  "or %2,%0",
  "or %2,%0",
  "or %2,%1,%0",
};

static const char * const output_29[] = {
  "xor %2,%0",
  "xor %2,%0",
  "xor %2,%1,%0",
};

static const char * const output_30[] = {
  "xor %2,%0",
  "xor %2,%0",
  "xor %2,%1,%0",
};

static const char *
output_34 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1398 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  /* The operands of CMP must be distinct registers.  In the case where
     we've failed to optimize the comparison of a register to itself, we
     must use another method to set the Z flag.  We can achieve this 
     effect with a BTST 0,D0.  This will not alter the contents of D0;
     the use of d0 is arbitrary; any data register would work.  */
  if (rtx_equal_p (operands[0], operands[1]))
    return "btst 0,d0";
  else
    return "cmp %1,%0";
}
}

static const char * const output_44[] = {
  "calls %C0",
  "call %C0,[],0",
};

static const char * const output_45[] = {
  "calls %C1",
  "call %C1,[],0",
};

static const char * const output_47[] = {
  "extbu %0",
  "movbu %1,%0",
  "extbu %1,%0",
};

static const char * const output_48[] = {
  "exthu %0",
  "movhu %1,%0",
  "exthu %1,%0",
};

static const char * const output_49[] = {
  "extb %0",
  "extb %1,%0",
};

static const char * const output_50[] = {
  "exth %0",
  "exth %1,%0",
};

static const char * const output_51[] = {
  "add %0,%0",
  "asl2 %0",
  "asl2 %0\n\tadd %0,%0",
  "asl2 %0\n\tasl2 %0",
  "asl %S2,%0",
  "asl %S2,%0",
  "asl %S2,%0",
  "asl %2,%1,%0",
};

static const char * const output_52[] = {
  "lsr %S2,%0",
  "lsr %S2,%0",
  "lsr %S2,%0",
  "lsr %2,%1,%0",
};

static const char * const output_53[] = {
  "asr %S2,%0",
  "asr %S2,%0",
  "asr %S2,%0",
  "asr %2,%1,%0",
};

static const char * const output_55[] = {
  "fabs %0",
  "fabs %1, %0",
};

static const char * const output_56[] = {
  "fneg %0",
  "fneg %1, %0",
};

static const char * const output_57[] = {
  "frsqrt %0",
  "frsqrt %1, %0",
};

static const char * const output_58[] = {
  "fadd %2, %0",
  "fadd %2, %1, %0",
};

static const char * const output_59[] = {
  "fsub %2, %0",
  "fsub %2, %1, %0",
};

static const char * const output_60[] = {
  "fmul %2, %0",
  "fmul %2, %1, %0",
};

static const char * const output_61[] = {
  "fdiv %2, %0",
  "fdiv %2, %1, %0",
};

static const char *
output_66 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2035 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  /* The RETF insn is 4 cycles faster than RETS, though 1 byte larger.  */
  if (optimize_insn_for_speed_p () && mn10300_can_use_retf_insn ())
    return "retf [],0";
  else
    return "rets";
}
}

static const char *
output_67 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2047 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  /* The RETF insn is up to 3 cycles faster than RET.  */
  fputs ((mn10300_can_use_retf_insn () ? "\tretf " : "\tret "), asm_out_file);
  mn10300_print_reg_list (asm_out_file, mn10300_get_live_callee_saved_regs (NULL));
  fprintf (asm_out_file, ",%d\n", (int) INTVAL (operands[0]));
  return "";
}
}

static const char *
output_68 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2060 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  fputs ("\tmovm ", asm_out_file);
  mn10300_print_reg_list (asm_out_file,
                          mn10300_store_multiple_regs (operands[0]));
  fprintf (asm_out_file, ",(sp)\n");
  return "";
}
}

static const char *
output_69 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2090 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  operands[1] = gen_rtx_SYMBOL_REF (VOIDmode, GOT_SYMBOL_NAME);
  return ".LPIC%=:\n\tmov pc,%0\n\tadd %1-(.LPIC%=-.),%0";
}
}

static const char *
output_70 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2104 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  operands[1] = gen_rtx_SYMBOL_REF (VOIDmode, GOT_SYMBOL_NAME);
  return ("add -4,sp\n\t"
	  "calls .LPIC%=\n"
          ".LPIC%=:\n\t"
	  "movm (sp),[%0]\n\t"
	  "add %1-(.LPIC%=-.),%0");
}
}

static const char *
output_71 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2123 "../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md"
{
  operands[1] = gen_rtx_SYMBOL_REF (VOIDmode, GOT_SYMBOL_NAME);
  return ("calls .LPIC%=\n"
	  ".LPIC%=:\n\t"
          "mov (sp),%0\n\t"
          "add %1-(.LPIC%=-.),%0");
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    nonimmediate_operand,
    "=*r,D*r,D*r,D,m,*z,d",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,D*r,i,m,D,d,*z",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=*r,D*r,D*r,D,m,*z,d",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,i,D*r,m,D,d,*z",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=r,r,r,r,m,r,A,*y,*y,*z,*d",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,O,i,r,r,m,*y,A,i,*d,*z",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "=rf,r,f,r,f,r,f,r,m,f,Q,z,d",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "0,F,F,r,f,f,r,m,r,Q,f,d,z",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=D",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r,r,!*y,!r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,0,0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "r,O,i,i,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,!r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "D,i,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,ri,ri",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "1,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "D,1,ri",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=X,X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=&r,&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%1,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "r,O,i,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "D,i,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "1,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,ri",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "D,ri",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=&r,&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "1,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=z,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=z,z,r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "%0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "D,ri,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=z",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "1",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=z",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=z",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "1",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "i,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "ri",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    label_ref_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "r,O,i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    int_mode_flags,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "D",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    label_ref_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    CCZN_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "fF",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    label_ref_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_address_operand,
    "a,S",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,m,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,m,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,D,d,d,D,D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0,0,0,0,0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "J,K,M,L,D,O,i,r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=D,D,D,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,0,0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "D,O,i,r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,?f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const_1f_operand,
    "F,F",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "f,?fF",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "f,?fF",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=c",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mn10300_store_multiple_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    liw_operand,
    "rO",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    liw_operand,
    "rO",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    liw_operand,
    "rO",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    liw_operand,
    "rO",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    impossible_plus_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=&A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    reg_or_am33_const_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    immediate_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:241 */
  {
    "*movqi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_1 },
#else
    { 0, 0, output_1 },
#endif
    { 0 },
    &operand_data[1],
    2,
    2,
    0,
    7,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:289 */
  {
    "*movhi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_2 },
#else
    { 0, 0, output_2 },
#endif
    { 0 },
    &operand_data[3],
    2,
    2,
    0,
    7,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:430 */
  {
    "*movsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_3 },
#else
    { 0, 0, output_3 },
#endif
    { 0 },
    &operand_data[5],
    2,
    2,
    0,
    11,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:503 */
  {
    "*movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_4 },
#else
    { 0, 0, output_4 },
#endif
    { 0 },
    &operand_data[7],
    2,
    2,
    0,
    13,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:569 */
  {
    "*movqi_clr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "clr %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[9],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:569 */
  {
    "*movhi_clr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "clr %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[10],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:569 */
  {
    "*movsi_clr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "clr %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[11],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:581 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_8 },
#else
    { 0, 0, output_8 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[12],
    3,
    3,
    0,
    5,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:594 */
  {
    "*addsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_9 },
#else
    { 0, 0, output_9 },
#endif
    { 0 },
    &operand_data[15],
    3,
    3,
    2,
    2,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:617 */
  {
    "addc_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addc_internal },
    &operand_data[18],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:662 */
  {
    "adddi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3_internal },
    &operand_data[21],
    6,
    7,
    3,
    3,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:741 */
  {
    "*adddi3_degenerate",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[28],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:775 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_13 },
#else
    { 0, output_13, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[33],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:792 */
  {
    "*subsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_14 },
#else
    { 0, output_14, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    2,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:818 */
  {
    "subc_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subc_internal },
    &operand_data[39],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:862 */
  {
    "subdi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3_internal },
    &operand_data[42],
    6,
    7,
    2,
    2,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:931 */
  {
    "*subdi3_degenerate",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[49],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:964 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[54],
    2,
    2,
    0,
    2,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1017 */
  {
    "mulsidi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_19 },
#else
    { 0, 0, output_19 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3_internal },
    &operand_data[56],
    4,
    4,
    2,
    2,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1055 */
  {
    "umulsidi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_20 },
#else
    { 0, 0, output_20 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3_internal },
    &operand_data[56],
    4,
    4,
    2,
    2,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1089 */
  {
    "*mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_21 },
#else
    { 0, 0, output_21 },
#endif
    { 0 },
    &operand_data[60],
    4,
    4,
    0,
    3,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1125 */
  {
    "*udivmodsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "divu %3,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[64],
    5,
    5,
    2,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1156 */
  {
    "ext_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ext %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ext_internal },
    &operand_data[69],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1163 */
  {
    "*divmodsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "div %3,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[71],
    5,
    5,
    2,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1182 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_25 },
#else
    { 0, output_25, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[76],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1198 */
  {
    "*andsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_26 },
#else
    { 0, output_26, 0 },
#endif
    { 0 },
    &operand_data[76],
    3,
    3,
    2,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1269 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_27 },
#else
    { 0, output_27, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[76],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1285 */
  {
    "*iorsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_28 },
#else
    { 0, output_28, 0 },
#endif
    { 0 },
    &operand_data[76],
    3,
    3,
    2,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1305 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_29 },
#else
    { 0, output_29, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[76],
    3,
    3,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1321 */
  {
    "*xorsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_30 },
#else
    { 0, output_30, 0 },
#endif
    { 0 },
    &operand_data[76],
    3,
    3,
    2,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1341 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "not %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[79],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1349 */
  {
    "*one_cmplsi2_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "not %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[79],
    2,
    2,
    1,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1377 */
  {
    "*cbranchsi4_cmp",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[81],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1393 */
  {
    "cmpsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_34 },
#else
    { 0, 0, output_34 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cmpsi },
    &operand_data[85],
    2,
    2,
    0,
    3,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1417 */
  {
    "*integer_conditional_branch",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b%b0 %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[87],
    3,
    3,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1428 */
  {
    "*cbranchsi4_btst",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[90],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1446 */
  {
    "*btstsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "btst %1,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[90],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1468 */
  {
    "*cbranchsf4_cmp",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[94],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1485 */
  {
    "*am33_cmpsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fcmp %1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[94],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1495 */
  {
    "*float_conditional_branch",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fb%b0 %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[87],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1509 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jmp %l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[88],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1518 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jmp (%0)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[98],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1561 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jmp (%0)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[98],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1599 */
  {
    "*call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { 0 },
    &operand_data[100],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1646 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[99],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1682 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1692 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_47 },
#else
    { 0, output_47, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[102],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1710 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_48 },
#else
    { 0, output_48, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[104],
    2,
    2,
    0,
    3,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1727 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_49 },
#else
    { 0, output_49, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[106],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1738 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_50 },
#else
    { 0, output_50, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[108],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1753 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_51 },
#else
    { 0, output_51, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[110],
    3,
    3,
    0,
    8,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1775 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_52 },
#else
    { 0, output_52, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[113],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1792 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_53 },
#else
    { 0, output_53, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[113],
    3,
    3,
    0,
    4,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1835 */
  {
    "*bsch",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "bsch %1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[116],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1849 */
  {
    "abssf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_55 },
#else
    { 0, output_55, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssf2 },
    &operand_data[119],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1860 */
  {
    "negsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_56 },
#else
    { 0, output_56, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsf2 },
    &operand_data[119],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1883 */
  {
    "rsqrtsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_57 },
#else
    { 0, output_57, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rsqrtsf2 },
    &operand_data[119],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1896 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_58 },
#else
    { 0, output_58, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[122],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1913 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_59 },
#else
    { 0, output_59, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[125],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1930 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_60 },
#else
    { 0, output_60, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[122],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1948 */
  {
    "divsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_61 },
#else
    { 0, output_61, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsf3 },
    &operand_data[125],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1965 */
  {
    "fmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmadd %1, %2, %3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmasf4 },
    &operand_data[128],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1978 */
  {
    "fmssf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmsub %1, %2, %3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmssf4 },
    &operand_data[128],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1991 */
  {
    "fnmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fnmadd %1, %2, %3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmasf4 },
    &operand_data[128],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2004 */
  {
    "fnmssf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fnmsub %1, %2, %3, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmssf4 },
    &operand_data[128],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2032 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_66 },
#else
    { 0, 0, output_66 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2043 */
  {
    "return_ret",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_67 },
#else
    { 0, 0, output_67 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return_ret },
    &operand_data[132],
    1,
    1,
    0,
    0,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2056 */
  {
    "store_movm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_68 },
#else
    { 0, 0, output_68 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_store_movm },
    &operand_data[133],
    2,
    2,
    0,
    0,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2085 */
  {
    "am33_load_pic",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_69 },
#else
    { 0, 0, output_69 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_am33_load_pic },
    &operand_data[135],
    1,
    1,
    0,
    1,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2098 */
  {
    "mn10300_load_pic0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_70 },
#else
    { 0, 0, output_70 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mn10300_load_pic0 },
    &operand_data[135],
    1,
    1,
    0,
    1,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2116 */
  {
    "mn10300_load_pic1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_71 },
#else
    { 0, 0, output_71 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mn10300_load_pic1 },
    &operand_data[135],
    1,
    1,
    0,
    1,
    3
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2135 */
  {
    "liw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%W4_%W5 %2, %0, %3, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_liw },
    &operand_data[136],
    6,
    6,
    2,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2154 */
  {
    "cmp_liw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "cmp_%W4 %3, %2, %1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cmp_liw },
    &operand_data[142],
    5,
    5,
    1,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2169 */
  {
    "liw_cmp",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%W4_cmp %1, %0, %3, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_liw_cmp },
    &operand_data[142],
    5,
    5,
    1,
    1,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2191 */
  {
    "setlb",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "setlb",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_setlb },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2197 */
  {
    "Lcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "L%b0 # loop back to: %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_Lcc },
    &operand_data[87],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2208 */
  {
    "FLcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "FL%b0 # loop back to: %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_FLcc },
    &operand_data[87],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:230 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[147],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:278 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[149],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:341 */
  {
    "reload_plus_sp_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reload_plus_sp_const },
    &operand_data[151],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:389 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[154],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:492 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[156],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:607 */
  {
    "addsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3_flags },
    &operand_data[158],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:633 */
  {
    "adddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3 },
    &operand_data[161],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:808 */
  {
    "subsi3_flags",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3_flags },
    &operand_data[158],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:833 */
  {
    "subdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3 },
    &operand_data[161],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1005 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[164],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1042 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[164],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1080 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[165],
    3,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1109 */
  {
    "udivmodsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivmodsi4 },
    &operand_data[169],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1139 */
  {
    "divmodsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divmodsi4 },
    &operand_data[169],
    4,
    4,
    3,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1365 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[173],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1456 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[177],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1526 */
  {
    "builtin_setjmp_receiver",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_builtin_setjmp_receiver },
    &operand_data[88],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1534 */
  {
    "casesi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_casesi },
    &operand_data[181],
    5,
    5,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1572 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[186],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1618 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[185],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1663 */
  {
    "untyped_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_untyped_call },
    &operand_data[188],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1823 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[158],
    2,
    2,
    2,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:1871 */
  {
    "sqrtsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sqrtsf2 },
    &operand_data[191],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2020 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2026 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.2.1-20240912/gcc/config/mn10300/mn10300.md:2072 */
  {
    "load_pic",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_load_pic },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
