/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_21 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_PDImode:
      if (!register_operand (operands[0], E_PDImode)
          || GET_MODE (x3) != E_PDImode
          || !register_operand (operands[1], E_PDImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 3
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 10)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != REG
      || REGNO (x16) != 34
      || GET_MODE (x16) != E_BImode)
    return -1;
  return 0;
}

static int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern5 (x1, E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern5 (x1, E_HImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern5 (x1, E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  if (!general_operand (operands[1], E_VOIDmode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_CODE (operands[0]))
    {
    case SYMBOL_REF:
      if (!symbol_ref_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_no_elim_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[0], E_V2PDImode)
      || GET_MODE (x1) != E_V2PDImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 1L:
      if (XWINT (x4, 0) != 0L)
        return -1;
      return 0;

    case 0L:
      if (XWINT (x4, 0) != 1L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  return pattern10 (x1); /* [-1, 1] */
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern13 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 34
      || GET_MODE (x6) != E_BImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!general_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_no_elim_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != ASHIFT
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XEXP (x9, 1);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x14) != SET)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != MEM
      || GET_MODE (x15) != E_BLKmode)
    return -1;
  x16 = XEXP (x14, 0);
  if (GET_CODE (x16) != MEM)
    return -1;
  return 0;
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (pattern5 (x1, E_V2HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return 0;
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || pattern20 (x2) != 0)
    return -1;
  return 0;
}

static int
pattern22 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_SELECT
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL
      || XVECLEN (x8, 0) != 1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XEXP (x2, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x15 = XEXP (x3, 0);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x16 = XEXP (x7, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x10, 0);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  return 0;
}

static int
pattern23 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern22 (x1, i1) != 0)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_PDImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  return 0;
}

static int
pattern26 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[3] = x7;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  operands[4] = x9;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  operands[5] = x10;
  return 0;
}

static int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != VEC_CONCAT
      || GET_MODE (x7) != E_V2HImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[3] = x13;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x14 = XVECEXP (x6, 0, 0);
  operands[4] = x14;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x16 = XVECEXP (x9, 0, 0);
  operands[5] = x16;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x17 = XVECEXP (x11, 0, 0);
  operands[6] = x17;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x18 = XVECEXP (x1, 0, 2);
  operands[7] = x18;
  x19 = XEXP (x5, 0);
  if (!rtx_equal_p (x19, operands[1]))
    return -1;
  x20 = XEXP (x10, 0);
  if (!rtx_equal_p (x20, operands[2]))
    return -1;
  return 0;
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 35
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 13
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_BImode))
    return -1;
  return 0;
}

static int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

static int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != VEC_CONCAT
      || GET_MODE (x7) != E_V2HImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1)
    return -1;
  return 0;
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      if (pnum_clobbers == NULL
          || !register_operand (operands[2], E_SImode))
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      return 0;

    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case RETURN:
      return 2;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vec_shift_operand (operands[2], E_HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x2, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[3] = x10;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x11 = XVECEXP (x4, 0, 0);
  operands[5] = x11;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  return 0;
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

static int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  operands[5] = x9;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      if (pnum_clobbers == NULL
          || !register_operand (operands[3], E_SImode))
        return -1;
      x2 = XEXP (x1, 0);
      operands[4] = x2;
      return 0;

    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case RETURN:
      return 2;

    default:
      return -1;
    }
}

static int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case RETURN:
      return 1;

    default:
      return -1;
    }
}

static int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 0L:
      return 0;

    case 1L:
      return 1;

    default:
      return -1;
    }
}

static int
pattern45 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != VEC_SELECT
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PARALLEL
      || XVECLEN (x16, 0) != 1)
    return -1;
  x17 = XVECEXP (x16, 0, 0);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern46 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (!register_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  switch (GET_CODE (x7))
    {
    case MEM:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x6;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 2
          || XINT (x13, 1) != 13
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XVECEXP (x13, 0, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != MEM
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x6;
      x10 = XVECEXP (x3, 0, 1);
      operands[3] = x10;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x14, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return -1;
      x18 = XVECEXP (x13, 0, 1);
      if (!rtx_equal_p (x18, operands[3]))
        return -1;
      x19 = XEXP (x11, 0);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_PDImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  return 0;
}

static int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[4] = x4;
  if (!register_no_elim_operand (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

static int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

static int
pattern50 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x5, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x4, 1);
  operands[2] = x11;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x9, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x8, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x6, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

static int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x9, 1);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PDImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[6] = x9;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  operands[10] = x10;
  return 0;
}

static int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ZERO_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  return 0;
}

static int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  x10 = XEXP (x7, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XVECEXP (x1, 0, 0);
  x15 = XEXP (x14, 1);
  x16 = XEXP (x15, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  switch (XWINT (x18, 0))
    {
    case 2L:
      x19 = XEXP (x15, 1);
      if (XWINT (x19, 0) != 4L)
        return -1;
      x20 = XEXP (x5, 1);
      if (XWINT (x20, 0) != 2L)
        return -1;
      x21 = XEXP (x3, 1);
      if (XWINT (x21, 0) != 4L)
        return -1;
      return 0;

    case 1L:
      x19 = XEXP (x15, 1);
      if (XWINT (x19, 0) != 2L)
        return -1;
      x20 = XEXP (x5, 1);
      if (XWINT (x20, 0) != 1L)
        return -1;
      x21 = XEXP (x3, 1);
      if (XWINT (x21, 0) != 2L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_PDImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[5] = x6;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[7] = x9;
  if (!const01_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[8] = x10;
  if (!register_operand (operands[8], E_PDImode))
    return -1;
  x11 = XVECEXP (x3, 0, 3);
  operands[9] = x11;
  if (!const01_operand (operands[9], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x3, 0, 4);
  operands[11] = x12;
  if (!const_int_operand (operands[11], E_VOIDmode))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

static int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 0L:
      return 0;

    case 1L:
      return 1;

    default:
      return -1;
    }
}

static int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 0);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 0;

    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      res = pattern56 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[3] = x6;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[4] = x9;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x13 = XEXP (x11, 1);
  x14 = XVECEXP (x13, 0, 0);
  operands[5] = x14;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x15 = XEXP (x10, 1);
  x16 = XEXP (x15, 1);
  x17 = XVECEXP (x16, 0, 0);
  operands[6] = x17;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x18 = XVECEXP (x1, 0, 2);
  operands[7] = x18;
  return 0;
}

static int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XVECEXP (x11, 0, 0);
  x13 = XEXP (x12, 0);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x13, 1);
  x16 = XVECEXP (x15, 0, 0);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = XEXP (x12, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x17, 1);
  x20 = XVECEXP (x19, 0, 0);
  if (!rtx_equal_p (x20, operands[4]))
    return -1;
  x21 = XVECEXP (x11, 0, 1);
  x22 = XEXP (x21, 0);
  x23 = XEXP (x22, 0);
  if (!rtx_equal_p (x23, operands[2]))
    return -1;
  x24 = XEXP (x22, 1);
  x25 = XVECEXP (x24, 0, 0);
  if (!rtx_equal_p (x25, operands[5]))
    return -1;
  x26 = XEXP (x21, 1);
  x27 = XEXP (x26, 0);
  if (!rtx_equal_p (x27, operands[2]))
    return -1;
  x28 = XEXP (x26, 1);
  x29 = XVECEXP (x28, 0, 0);
  if (!rtx_equal_p (x29, operands[5]))
    return -1;
  x30 = XVECEXP (x11, 0, 2);
  if (!rtx_equal_p (x30, operands[7]))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_BImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_BImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_CODE (x4))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern35 (x3, E_QImode) != 0)
            return -1;
          return 1; /* *movqicc_insn1 */

        case E_HImode:
          if (pattern35 (x3, E_HImode) != 0)
            return -1;
          return 2; /* *movhicc_insn1 */

        case E_SImode:
          if (pattern35 (x3, E_SImode) != 0)
            return -1;
          return 3; /* *movsicc_insn1 */

        default:
          return -1;
        }

    case NE:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern35 (x3, E_QImode) != 0)
            return -1;
          return 4; /* *movqicc_insn2 */

        case E_HImode:
          if (pattern35 (x3, E_HImode) != 0)
            return -1;
          return 5; /* *movhicc_insn2 */

        case E_SImode:
          if (pattern35 (x3, E_SImode) != 0)
            return -1;
          return 6; /* *movsicc_insn2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x4;
                  if (immediate_operand (operands[1], E_SImode)
                      && 
#line 460 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                    return 7; /* movsi_high */
                  break;

                case UNSPEC:
                  if (XVECLEN (x4, 0) == 1
                      && XINT (x4, 1) == 3
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XVECEXP (x4, 0, 0);
                      operands[1] = x5;
                      return 10; /* movsi_high_pic */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 93; /* jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!immediate_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != STRICT_LOW_PART)
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  return 27; /* movstricthi_1 */
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (register_operand (operands[0], E_SImode))
        {
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case MEM:
              if (GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) == PRE_DEC
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XEXP (x4, 0);
                      if (GET_CODE (x5) == REG
                          && REGNO (x5) == 14
                          && GET_MODE (x5) == E_SImode)
                        return 17; /* *pushsi_insn */
                    }
                }
              break;

            case PC:
              return 94; /* indirect_jump */

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XEXP (x3, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  return 26; /* *movsi_insv */
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 11
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 20; /* *movsi_insn32 */

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 2);
      if (!const_int_operand (x5, E_VOIDmode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 6:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern33 (x2, E_HImode) != 0)
                    return -1;
                  return 180; /* flag_mulhi */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !register_operand (operands[1], E_HImode)
                      || !register_operand (operands[2], E_HImode))
                    return -1;
                  return 182; /* flag_mulhisi */

                case E_V2HImode:
                  if (pattern33 (x2, E_V2HImode) != 0)
                    return -1;
                  return 190; /* flag_mulv2hi */

                default:
                  return -1;
                }

            case VEC_SELECT:
              if (pattern27 (x2) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x2) != E_HImode)
                    return -1;
                  return 181; /* flag_mulhi_parts */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode)
                    return -1;
                  return 183; /* flag_mulhisi_parts */

                default:
                  return -1;
                }

            case VEC_CONCAT:
              if (pattern28 (x2, E_V2HImode) != 0)
                return -1;
              return 191; /* flag_mulv2hi_parts */

            default:
              return -1;
            }

        case 7:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode)
                return -1;
              x6 = XVECEXP (x2, 0, 1);
              operands[2] = x6;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              operands[3] = x5;
              return 188; /* flag_macinit1hi */

            case VEC_CONCAT:
              if (pattern28 (x2, E_V2PDImode) != 0)
                return -1;
              return 195; /* flag_macinit1v2hi_parts */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      if (XINT (x2, 1) != 7
          || GET_MODE (x2) != E_PDImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_PDImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (!const01_operand (x7, E_VOIDmode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      if (!const_int_operand (x8, E_VOIDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          x5 = XVECEXP (x2, 0, 2);
          operands[3] = x5;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x7;
          operands[5] = x8;
          return 185; /* flag_machi_acconly */

        case VEC_SELECT:
          if (pattern27 (x2) != 0
              || !register_operand (operands[5], E_PDImode))
            return -1;
          operands[6] = x7;
          operands[7] = x8;
          return 186; /* flag_machi_parts_acconly */

        default:
          return -1;
        }

    case 6:
      if (XINT (x2, 1) != 7
          || GET_MODE (x2) != E_V2PDImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != VEC_CONCAT
          || GET_MODE (x4) != E_V2HImode)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_HImode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x6) != VEC_CONCAT
          || GET_MODE (x6) != E_V2HImode)
        return -1;
      x13 = XEXP (x6, 0);
      if (GET_CODE (x13) != VEC_SELECT
          || GET_MODE (x13) != E_HImode)
        return -1;
      x14 = XEXP (x13, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XEXP (x6, 1);
      if (GET_CODE (x15) != VEC_SELECT
          || GET_MODE (x15) != E_HImode)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != PARALLEL
          || XVECLEN (x16, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2PDImode))
        return -1;
      x17 = XEXP (x9, 0);
      operands[1] = x17;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x18 = XVECEXP (x10, 0, 0);
      operands[3] = x18;
      if (!const01_operand (operands[3], E_VOIDmode))
        return -1;
      x19 = XVECEXP (x12, 0, 0);
      operands[4] = x19;
      if (!const01_operand (operands[4], E_VOIDmode))
        return -1;
      x20 = XEXP (x13, 0);
      operands[2] = x20;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x21 = XVECEXP (x14, 0, 0);
      operands[5] = x21;
      if (!const01_operand (operands[5], E_VOIDmode))
        return -1;
      x22 = XVECEXP (x16, 0, 0);
      operands[6] = x22;
      if (!const01_operand (operands[6], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[7] = x5;
      if (!register_operand (operands[7], E_V2PDImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[8] = x7;
      if (!const01_operand (operands[8], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[9] = x8;
      if (!const01_operand (operands[9], E_VOIDmode))
        return -1;
      x23 = XVECEXP (x2, 0, 5);
      operands[10] = x23;
      if (!const_int_operand (operands[10], E_VOIDmode))
        return -1;
      x24 = XEXP (x11, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x25 = XEXP (x15, 0);
      if (!rtx_equal_p (x25, operands[2]))
        return -1;
      return 193; /* flag_macv2hi_parts_acconly */

    case 2:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 13
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x26 = XEXP (x3, 0);
      operands[0] = x26;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!register_no_elim_operand (operands[2], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (pattern40 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 245; /* sync_addsi_internal */

        case MINUS:
          if (pattern40 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 246; /* sync_subsi_internal */

        case IOR:
          if (pattern40 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 247; /* sync_iorsi_internal */

        case AND:
          if (pattern40 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 248; /* sync_andsi_internal */

        case XOR:
          if (pattern40 (x4) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 249; /* sync_xorsi_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 47; /* mulhisi3 */

        case VEC_SELECT:
          if (pattern20 (x6) != 0)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != VEC_SELECT
              || GET_MODE (x7) != E_HImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 1)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          x12 = XEXP (x6, 1);
          x13 = XVECEXP (x12, 0, 0);
          switch (XWINT (x13, 0))
            {
            case 0L:
              switch (XWINT (x9, 0))
                {
                case 0L:
                  return 197; /* mulhisi_ll */

                case 1L:
                  return 199; /* mulhisi_lh */

                default:
                  return -1;
                }

            case 1L:
              switch (XWINT (x9, 0))
                {
                case 0L:
                  return 201; /* mulhisi_hl */

                case 1L:
                  return 203; /* mulhisi_hh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 48; /* umulhisi3 */

            case SIGN_EXTEND:
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 49; /* usmulhisi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern20 (x6) != 0)
            return -1;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x12 = XEXP (x6, 1);
          x13 = XVECEXP (x12, 0, 0);
          switch (XWINT (x13, 0))
            {
            case 0L:
              switch (GET_CODE (x5))
                {
                case ZERO_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern44 (x7))
                    {
                    case 0:
                      return 198; /* umulhisi_ll */

                    case 1:
                      return 200; /* umulhisi_lh */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern44 (x7))
                    {
                    case 0:
                      return 205; /* usmulhisi_ull */

                    case 1:
                      return 206; /* usmulhisi_ulh */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1L:
              switch (GET_CODE (x5))
                {
                case ZERO_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern44 (x7))
                    {
                    case 0:
                      return 202; /* umulhisi_hl */

                    case 1:
                      return 204; /* umulhisi_hh */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern44 (x7))
                    {
                    case 0:
                      return 207; /* usmulhisi_uhl */

                    case 1:
                      return 208; /* usmulhisi_uhh */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern5 (x3, E_SImode) != 0)
            return -1;
          return 80; /* mulsi3 */

        case E_V2HImode:
          if (pattern5 (x3, E_V2HImode) != 0)
            return -1;
          return 189; /* mulv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) == POST_INC
              && GET_MODE (x3) == E_SImode)
            {
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) == REG
                  && REGNO (x4) == 14
                  && GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x1, 0);
                  operands[0] = x5;
                  if (register_operand (operands[0], E_SImode))
                    return 18; /* *popsi_insn */
                }
            }
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode)
          && 
#line 507 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 12; /* movdi_insn */
      break;

    case E_BImode:
      if (nonimmediate_operand (operands[0], E_BImode)
          && general_operand (operands[1], E_BImode))
        return 13; /* movbi */
      break;

    case E_PDImode:
      if (nonimmediate_operand (operands[0], E_PDImode)
          && general_operand (operands[1], E_PDImode))
        return 14; /* movpdi */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 609 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 19; /* *movsi_insn */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode)
          && 
#line 649 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 21; /* *movv2hi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 671 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 22; /* *movhi_insn */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 695 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 23; /* *movqi_insn */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 708 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 24; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode)
          && 
#line 719 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 25; /* movdf_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
    return -1;
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 244; /* loadbytes */
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2HImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          return 149; /* movhiv2hi_low */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 151; /* composev2hi */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern12 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XVECEXP (x10, 0, 0);
      if (XWINT (x11, 0) == 0L)
        {
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[2] = x5;
              if (register_operand (operands[2], E_HImode))
                return 150; /* movhiv2hi_high */
              break;

            case SS_PLUS:
              if (pattern41 (x5) == 0)
                return 158; /* ssaddhi3_low_parts */
              break;

            case SS_MINUS:
              if (pattern41 (x5) == 0)
                return 159; /* sssubhi3_low_parts */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      operands[3] = x11;
      if (!const01_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      if (!const01_operand (operands[4], E_VOIDmode))
        return -1;
      return 152; /* packv2hi */

    case SS_PLUS:
      if (pattern21 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      operands[4] = x13;
      if (pattern38 (x2) == 0)
        return 160; /* ssaddhi3_high_parts */
      if (XWINT (x13, 0) != 0L
          || pattern22 (x2, SS_MINUS) != 0)
        return -1;
      return 169; /* sssubaddv2hi3 */

    case SS_MINUS:
      if (pattern21 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      operands[4] = x13;
      if (pattern38 (x2) == 0)
        return 161; /* sssubhi3_high_parts */
      if (XWINT (x13, 0) != 0L
          || pattern22 (x2, SS_PLUS) != 0)
        return -1;
      return 168; /* ssaddsubv2hi3 */

    case MINUS:
      if (pattern23 (x2, PLUS) != 0)
        return -1;
      return 166; /* addsubv2hi3 */

    case PLUS:
      if (pattern23 (x2, MINUS) != 0)
        return -1;
      return 167; /* subaddv2hi3 */

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (!bfin_bimode_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      operands[2] = x4;
      if (!immediate_operand (operands[2], E_BImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      return 124; /* cbranchbi4 */

    case LT:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[2] = x8;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ASHIFTRT:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != SS_ASHIFT)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x10 = XEXP (x5, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          x11 = XEXP (x6, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x6, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern37 (x2, E_V2HImode) != 0)
                return -1;
              return 239; /* ssashiftv2hi3 */

            case E_HImode:
              if (pattern37 (x2, E_HImode) != 0)
                return -1;
              return 240; /* ssashifthi3 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_const_int_operand (operands[2], E_HImode)
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 241; /* ssashiftsi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != ASHIFT
              || !vec_shift_operand (operands[2], E_HImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x10 = XEXP (x5, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          x11 = XEXP (x6, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x6, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern39 (x2, E_V2HImode) != 0)
                return -1;
              return 242; /* lshiftv2hi3 */

            case E_HImode:
              if (pattern39 (x2, E_HImode) != 0)
                return -1;
              return 243; /* lshifthi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT
          || XWINT (x5, 0) != 65535L)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 469 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
        return -1;
      return 8; /* movstricthi_high */

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!regorlog2_operand (operands[2], E_SImode))
        return -1;
      return 62; /* iorsi3 */

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 24L:
          if (XWINT (x8, 0) != 8L)
            return -1;
          return 133; /* *bfin.md:2628 */

        case 16L:
          if (XWINT (x8, 0) != 16L)
            return -1;
          return 134; /* *bfin.md:2638 */

        case 8L:
          if (XWINT (x8, 0) != 24L)
            return -1;
          return 135; /* *bfin.md:2648 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_PDImode:
      if (register_operand (operands[0], E_PDImode)
          && memory_operand (operands[1], E_PDImode))
        return 89; /* reload_inpdi */
      if (!memory_operand (operands[0], E_PDImode)
          || !register_operand (operands[1], E_PDImode))
        return -1;
      return 91; /* reload_outpdi */

    case E_V2PDImode:
      if (register_operand (operands[0], E_V2PDImode)
          && memory_operand (operands[1], E_V2PDImode))
        return 90; /* reload_inv2pdi */
      if (!memory_operand (operands[0], E_V2PDImode)
          || !register_operand (operands[1], E_V2PDImode))
        return -1;
      return 92; /* reload_outv2pdi */

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  switch (XVECLEN (x6, 0))
    {
    case 5:
      if (XINT (x6, 1) != 7
          || GET_MODE (x6) != E_HImode
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 7
          || GET_MODE (x3) != E_PDImode
          || !register_operand (operands[0], E_HImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      operands[4] = x9;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      operands[5] = x10;
      if (!const01_operand (operands[5], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      operands[6] = x11;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x12 = XEXP (x2, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_PDImode))
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x3, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      x16 = XVECEXP (x3, 0, 3);
      if (!rtx_equal_p (x16, operands[4]))
        return -1;
      x17 = XVECEXP (x3, 0, 4);
      if (!rtx_equal_p (x17, operands[5]))
        return -1;
      return 184; /* flag_machi */

    case 3:
      if (XINT (x3, 1) != 7)
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (!const_int_operand (x9, E_VOIDmode))
        return -1;
      switch (XINT (x6, 1))
        {
        case 7:
          if (XVECLEN (x3, 0) != 3)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_HImode)
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x6) != E_HImode)
                return -1;
              x8 = XVECEXP (x6, 0, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              operands[3] = x9;
              x12 = XEXP (x2, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_PDImode)
                  || GET_MODE (x3) != E_PDImode)
                return -1;
              x13 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XVECEXP (x3, 0, 1);
              if (!rtx_equal_p (x14, operands[2]))
                return -1;
              x15 = XVECEXP (x3, 0, 2);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              return 187; /* flag_macinithi */

            case VEC_CONCAT:
              if (pattern34 (x6) != 0)
                return -1;
              x13 = XVECEXP (x3, 0, 0);
              if (GET_CODE (x13) != VEC_CONCAT
                  || GET_MODE (x13) != E_V2HImode)
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != VEC_SELECT
                  || GET_MODE (x18) != E_HImode)
                return -1;
              x19 = XEXP (x18, 1);
              if (GET_CODE (x19) != PARALLEL
                  || XVECLEN (x19, 0) != 1)
                return -1;
              x20 = XEXP (x13, 1);
              if (GET_CODE (x20) != VEC_SELECT
                  || GET_MODE (x20) != E_HImode)
                return -1;
              x21 = XEXP (x20, 1);
              if (GET_CODE (x21) != PARALLEL
                  || XVECLEN (x21, 0) != 1)
                return -1;
              x14 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x14) != VEC_CONCAT
                  || GET_MODE (x14) != E_V2HImode)
                return -1;
              x22 = XEXP (x14, 0);
              if (GET_CODE (x22) != VEC_SELECT
                  || GET_MODE (x22) != E_HImode)
                return -1;
              x23 = XEXP (x22, 1);
              if (GET_CODE (x23) != PARALLEL
                  || XVECLEN (x23, 0) != 1)
                return -1;
              x24 = XEXP (x14, 1);
              if (GET_CODE (x24) != VEC_SELECT
                  || GET_MODE (x24) != E_HImode)
                return -1;
              x25 = XEXP (x24, 1);
              if (GET_CODE (x25) != PARALLEL
                  || XVECLEN (x25, 0) != 1
                  || !register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x6) != E_V2HImode
                  || pattern58 (x6) != 0)
                return -1;
              x12 = XEXP (x2, 0);
              operands[8] = x12;
              if (!register_operand (operands[8], E_V2PDImode)
                  || GET_MODE (x3) != E_V2PDImode
                  || pattern59 (x1) != 0)
                return -1;
              return 194; /* flag_macinitv2hi_parts */

            default:
              return -1;
            }

        case 6:
          if (pattern25 (x6) != 0
              || XVECLEN (x3, 0) != 5
              || pattern47 (x3) != 0
              || pattern52 (x6) != 0
              || pattern55 (x2) != 0
              || !
#line 3609 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(MACFLAGS_MATCH_P (INTVAL (operands[10]), INTVAL (operands[11]))))
            return -1;
          return 196; /* flag_mul_macv2hi_parts_acconly */

        default:
          return -1;
        }

    case 6:
      if (XINT (x6, 1) != 7
          || GET_MODE (x6) != E_V2HImode)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != VEC_CONCAT
          || pattern34 (x6) != 0
          || XVECLEN (x3, 0) != 6
          || XINT (x3, 1) != 7
          || GET_MODE (x3) != E_V2PDImode)
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x13) != VEC_CONCAT
          || GET_MODE (x13) != E_V2HImode)
        return -1;
      x18 = XEXP (x13, 0);
      if (GET_CODE (x18) != VEC_SELECT
          || GET_MODE (x18) != E_HImode)
        return -1;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != PARALLEL
          || XVECLEN (x19, 0) != 1)
        return -1;
      x20 = XEXP (x13, 1);
      if (GET_CODE (x20) != VEC_SELECT
          || GET_MODE (x20) != E_HImode)
        return -1;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != PARALLEL
          || XVECLEN (x21, 0) != 1)
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x14) != VEC_CONCAT
          || GET_MODE (x14) != E_V2HImode)
        return -1;
      x22 = XEXP (x14, 0);
      if (GET_CODE (x22) != VEC_SELECT
          || GET_MODE (x22) != E_HImode)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != PARALLEL
          || XVECLEN (x23, 0) != 1)
        return -1;
      x24 = XEXP (x14, 1);
      if (GET_CODE (x24) != VEC_SELECT
          || GET_MODE (x24) != E_HImode)
        return -1;
      x25 = XEXP (x24, 1);
      if (GET_CODE (x25) != PARALLEL
          || XVECLEN (x25, 0) != 1
          || !register_operand (operands[0], E_V2HImode)
          || pattern58 (x6) != 0
          || !register_operand (operands[7], E_V2PDImode))
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      operands[8] = x10;
      if (!const01_operand (operands[8], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      operands[9] = x11;
      if (!const01_operand (operands[9], E_VOIDmode))
        return -1;
      x26 = XVECEXP (x6, 0, 5);
      operands[10] = x26;
      if (!const_int_operand (operands[10], E_VOIDmode))
        return -1;
      x12 = XEXP (x2, 0);
      operands[11] = x12;
      if (!register_operand (operands[11], E_V2PDImode)
          || pattern59 (x1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 3);
      if (!rtx_equal_p (x16, operands[8]))
        return -1;
      x17 = XVECEXP (x3, 0, 4);
      if (!rtx_equal_p (x17, operands[9]))
        return -1;
      x27 = XVECEXP (x3, 0, 5);
      if (!rtx_equal_p (x27, operands[10]))
        return -1;
      return 192; /* flag_macv2hi_parts */

    case 2:
      if (pnum_clobbers == NULL
          || XINT (x6, 1) != 13
          || GET_MODE (x6) != E_SImode
          || pattern30 (x2) != 0
          || !register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      operands[3] = x8;
      if (!register_no_elim_operand (operands[3], E_SImode))
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (pattern50 (x1, PLUS) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 255; /* sync_new_addsi_internal */

        case MINUS:
          if (pattern50 (x1, MINUS) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 256; /* sync_new_subsi_internal */

        case IOR:
          if (pattern50 (x1, IOR) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 257; /* sync_new_iorsi_internal */

        case AND:
          if (pattern50 (x1, AND) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 258; /* sync_new_andsi_internal */

        case XOR:
          if (pattern50 (x1, XOR) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 259; /* sync_new_xorsi_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (pattern24 (x5, LTU, NOT, E_BImode) != 0
              || pattern31 (x1) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[2]))
            return -1;
          return 40; /* add_with_carry */

        case MINUS:
          if (pattern13 (x1, E_BImode, LEU) != 0
              || pattern31 (x1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          return 41; /* sub_with_carry */

        case SS_TRUNCATE:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != SS_PLUS
              || GET_MODE (x9) != E_PDImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != SS_PLUS
              || GET_MODE (x5) != E_PDImode)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_PDImode))
            return -1;
          x12 = XEXP (x9, 1);
          operands[3] = x12;
          if (!register_operand (operands[3], E_PDImode))
            return -1;
          x13 = XEXP (x4, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_PDImode))
            return -1;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[3]))
            return -1;
          return 55; /* sum_of_accumulators */

        case ZERO_EXTRACT:
          switch (pattern14 (x1))
            {
            case 0:
              return 59; /* *bit_extract */

            case 1:
              return 60; /* *not_bit_extract */

            default:
              return -1;
            }

        case IOR:
          if (pattern13 (x1, E_BImode, ZERO_EXTRACT) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 1);
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x14 = XEXP (x5, 2);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x13 = XEXP (x4, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 34
              || GET_MODE (x13) != E_BImode)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || GET_CODE (x15) != ASHIFT)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != ZERO_EXTEND
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 34
                  || GET_MODE (x17) != E_BImode)
                return -1;
              x18 = XEXP (x15, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || XWINT (x14, 0) != 0L)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              return 84; /* ror_one */

            case ASHIFT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || GET_CODE (x15) != ZERO_EXTEND)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 34
                  || GET_MODE (x16) != E_BImode
                  || XWINT (x14, 0) != 31L)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              return 85; /* rol_one */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x10 = XEXP (x2, 0);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
            case MEM:
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case PC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) == USE)
                {
                  x13 = XEXP (x4, 0);
                  if (GET_CODE (x13) == LABEL_REF)
                    {
                      operands[0] = x3;
                      if (register_operand (operands[0], E_SImode))
                        {
                          x19 = XEXP (x13, 0);
                          operands[1] = x19;
                          return 95; /* *tablejump_internal */
                        }
                    }
                }
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL
              || GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XINT (x5, 1) != 13)
            return -1;
          x13 = XEXP (x4, 0);
          if (GET_CODE (x13) != MEM
              || GET_MODE (x13) != E_SImode)
            return -1;
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x19 = XEXP (x13, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          switch (XVECLEN (x5, 0))
            {
            case 2:
              x20 = XVECEXP (x5, 0, 0);
              if (GET_MODE (x20) != E_SImode)
                return -1;
              x21 = XVECEXP (x5, 0, 1);
              operands[3] = x21;
              if (!register_no_elim_operand (operands[3], E_SImode))
                return -1;
              switch (GET_CODE (x20))
                {
                case PLUS:
                  if (pattern49 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 250; /* sync_old_addsi_internal */

                case MINUS:
                  if (pattern49 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 251; /* sync_old_subsi_internal */

                case IOR:
                  if (pattern49 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 252; /* sync_old_iorsi_internal */

                case AND:
                  if (pattern49 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 253; /* sync_old_andsi_internal */

                case XOR:
                  if (pattern49 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 254; /* sync_old_xorsi_internal */

                default:
                  return -1;
                }

            case 4:
              x20 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x20) != MEM
                  || GET_MODE (x20) != E_SImode
                  || pattern48 (x5) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 260; /* sync_compare_and_swapsi_internal */

            default:
              return -1;
            }

        case CALL:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern15 (x1))
            {
            case 0:
              if (!
#line 2229 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                return -1;
              *pnum_clobbers = 1;
              return 110; /* *call_value_symbol */

            case 1:
              if (!
#line 2277 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              *pnum_clobbers = 1;
              return 114; /* *call_value_insn */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x9 = XEXP (x3, 0);
          if (!bfin_bimode_comparison_operator (x9, E_VOIDmode))
            return -1;
          operands[0] = x9;
          x15 = XEXP (x3, 1);
          if (GET_CODE (x15) != LABEL_REF)
            return -1;
          x22 = XEXP (x3, 2);
          if (GET_CODE (x22) != PC)
            return -1;
          x10 = XEXP (x2, 0);
          if (GET_CODE (x10) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1)
            return -1;
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x12 = XEXP (x9, 1);
          operands[2] = x12;
          if (!immediate_operand (operands[2], E_BImode))
            return -1;
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          switch (XINT (x4, 1))
            {
            case 0:
              x23 = XVECEXP (x4, 0, 0);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 125; /* cbranch_predicted_taken */

            case 1:
              x23 = XVECEXP (x4, 0, 0);
              operands[4] = x23;
              if (!immediate_operand (operands[4], E_VOIDmode)
                  || !
#line 2528 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                return -1;
              return 126; /* cbranch_with_nops */

            default:
              return -1;
            }

        case UNSPEC:
          return recog_11 (x1, insn, pnum_clobbers);

        case MULT:
          if (pattern13 (x1, E_SImode, MULT) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x4, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              if (pattern45 (x1, SIGN_EXTEND) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              x24 = XEXP (x11, 0);
              operands[1] = x24;
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_V2HImode))
                return -1;
              x7 = XEXP (x6, 0);
              x25 = XEXP (x7, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x26 = XEXP (x11, 1);
              x27 = XVECEXP (x26, 0, 0);
              switch (XWINT (x27, 0))
                {
                case 0L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          switch (pattern57 (x8))
                            {
                            case 0:
                              return 209; /* mulhisi_ll_lh */

                            case 1:
                              return 221; /* usmulhisi_ll_lul */

                            case 2:
                              return 222; /* usmulhisi_ll_luh */

                            default:
                              return -1;
                            }

                        case 1L:
                          switch (GET_CODE (x8))
                            {
                            case SIGN_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern56 (x32))
                                {
                                case 0:
                                  return 211; /* mulhisi_ll_hl */

                                case 1:
                                  return 213; /* mulhisi_ll_hh */

                                default:
                                  return -1;
                                }

                            case ZERO_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern56 (x32))
                                {
                                case 0:
                                  return 223; /* usmulhisi_ll_hul */

                                case 1:
                                  return 224; /* usmulhisi_ll_huh */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 1L:
                          switch (GET_CODE (x8))
                            {
                            case SIGN_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern56 (x32))
                                {
                                case 0:
                                  return 215; /* mulhisi_lh_hl */

                                case 1:
                                  return 217; /* mulhisi_lh_hh */

                                default:
                                  return -1;
                                }

                            case ZERO_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern56 (x32))
                                {
                                case 0:
                                  return 227; /* usmulhisi_lh_hul */

                                case 1:
                                  return 228; /* usmulhisi_lh_huh */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        case 0L:
                          if (GET_CODE (x8) != ZERO_EXTEND)
                            return -1;
                          x32 = XEXP (x8, 0);
                          switch (pattern56 (x32))
                            {
                            case 0:
                              return 225; /* usmulhisi_lh_lul */

                            case 1:
                              return 226; /* usmulhisi_lh_luh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 1L:
                          switch (pattern57 (x8))
                            {
                            case 0:
                              return 219; /* mulhisi_hl_hh */

                            case 1:
                              return 231; /* usmulhisi_hl_hul */

                            case 2:
                              return 232; /* usmulhisi_hl_huh */

                            default:
                              return -1;
                            }

                        case 0L:
                          if (GET_CODE (x8) != ZERO_EXTEND)
                            return -1;
                          x32 = XEXP (x8, 0);
                          switch (pattern56 (x32))
                            {
                            case 0:
                              return 229; /* usmulhisi_hl_lul */

                            case 1:
                              return 230; /* usmulhisi_hl_luh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      if (pattern53 (x8) != 0)
                        return -1;
                      x32 = XEXP (x8, 0);
                      x33 = XEXP (x32, 0);
                      if (!rtx_equal_p (x33, operands[2]))
                        return -1;
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 233; /* usmulhisi_hh_lul */

                            case 1L:
                              return 234; /* usmulhisi_hh_luh */

                            default:
                              return -1;
                            }

                        case 1L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 235; /* usmulhisi_hh_hul */

                            case 1L:
                              return 236; /* usmulhisi_hh_huh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern45 (x1, ZERO_EXTEND) != 0
                  || pattern53 (x8) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              x24 = XEXP (x11, 0);
              operands[1] = x24;
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_V2HImode))
                return -1;
              x7 = XEXP (x6, 0);
              x25 = XEXP (x7, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x32 = XEXP (x8, 0);
              x33 = XEXP (x32, 0);
              if (!rtx_equal_p (x33, operands[2]))
                return -1;
              x26 = XEXP (x11, 1);
              x27 = XVECEXP (x26, 0, 0);
              switch (XWINT (x27, 0))
                {
                case 0L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          if (XWINT (x35, 0) != 1L)
                            return -1;
                          return 210; /* umulhisi_ll_lh */

                        case 1L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 212; /* umulhisi_ll_hl */

                            case 1L:
                              return 214; /* umulhisi_ll_hh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      if (XWINT (x31, 0) != 1L)
                        return -1;
                      x34 = XEXP (x32, 1);
                      x35 = XVECEXP (x34, 0, 0);
                      switch (XWINT (x35, 0))
                        {
                        case 0L:
                          return 216; /* umulhisi_lh_hl */

                        case 1L:
                          return 218; /* umulhisi_lh_hh */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  if (XWINT (x29, 0) != 0L)
                    return -1;
                  x30 = XEXP (x7, 1);
                  x31 = XVECEXP (x30, 0, 0);
                  if (XWINT (x31, 0) != 1L)
                    return -1;
                  x34 = XEXP (x32, 1);
                  x35 = XVECEXP (x34, 0, 0);
                  if (XWINT (x35, 0) != 1L)
                    return -1;
                  return 220; /* umulhisi_hl_hh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern7 (x1))
        {
        case 0:
          if (!
#line 2202 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 108; /* *call_symbol */

        case 1:
          if (!
#line 2256 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
            return -1;
          *pnum_clobbers = 1;
          return 112; /* *call_insn */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x36 = XVECEXP (x2, 0, 0);
      operands[1] = x36;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x4, 0);
      operands[0] = x13;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 136; /* eh_store_handler */

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x13 = XEXP (x4, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 2746 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
        return -1;
      return 142; /* return_internal */

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pattern4 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  return 96; /* loop_end */
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern26 (x2, 15) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 1);
  if (pattern24 (x4, MEM, PLUS, E_SImode) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 15
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 15
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 14
      || GET_MODE (x12) != E_SImode)
    return -1;
  return 139; /* unlink */
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != NE)
            return -1;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x3, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x10, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != UNSPEC
              || XVECLEN (x12, 0) != 1
              || XINT (x12, 1) != 10)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x16 = XEXP (x9, 0);
          operands[0] = x16;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x17 = XEXP (x10, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          *pnum_clobbers = 2;
          return 96; /* loop_end */

        case LABEL_REF:
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!lt_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x16 = XEXP (x9, 0);
          operands[2] = x16;
          if (!lb_register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x10, 0);
          operands[3] = x17;
          x12 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x12))
            {
            case SET:
              x18 = XEXP (x12, 0);
              operands[4] = x18;
              if (!lc_register_operand (operands[4], E_SImode))
                return -1;
              x19 = XEXP (x12, 1);
              operands[5] = x19;
              if (!register_operand (operands[5], E_SImode))
                return -1;
              return 97; /* lsetup_with_autoinit */

            case USE:
              x18 = XEXP (x12, 0);
              operands[4] = x18;
              if (!lc_register_operand (operands[4], E_SImode))
                return -1;
              return 98; /* lsetup_without_autoinit */

            default:
              return -1;
            }

        case CALL:
          switch (pattern15 (x1))
            {
            case 0:
              x12 = XVECEXP (x1, 0, 2);
              switch (pattern42 (x12, pnum_clobbers))
                {
                case 0:
                  if (!
#line 2130 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 102; /* *call_value_symbol_fdpic */

                case 1:
                  if (!
#line 2229 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                    return -1;
                  return 110; /* *call_value_symbol */

                case 2:
                  if (!
#line 2243 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                    return -1;
                  return 111; /* *sibcall_value_symbol */

                default:
                  return -1;
                }

            case 1:
              x12 = XVECEXP (x1, 0, 2);
              switch (pattern42 (x12, pnum_clobbers))
                {
                case 0:
                  if (!
#line 2180 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 106; /* *call_value_insn_fdpic */

                case 1:
                  if (!
#line 2277 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  return 114; /* *call_value_insn */

                case 2:
                  if (!
#line 2288 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 115; /* *sibcall_value_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 3
              || XINT (x3, 1) != 6
              || pattern25 (x3) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != UNSPEC
              || XVECLEN (x10, 0) != 5
              || XINT (x10, 1) != 7
              || pattern47 (x10) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != SET)
            return -1;
          x19 = XEXP (x12, 1);
          if (GET_CODE (x19) != AND
              || GET_MODE (x19) != E_BImode)
            return -1;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 34
              || GET_MODE (x20) != E_BImode)
            return -1;
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 3
              || XINT (x21, 1) != 6
              || GET_MODE (x21) != E_BImode)
            return -1;
          x22 = XVECEXP (x21, 0, 0);
          if (GET_CODE (x22) != VEC_SELECT
              || GET_MODE (x22) != E_HImode)
            return -1;
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x21, 0, 1);
          if (GET_CODE (x24) != VEC_SELECT
              || GET_MODE (x24) != E_HImode)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != PARALLEL
              || XVECLEN (x25, 0) != 1)
            return -1;
          x18 = XEXP (x12, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 34
              || GET_MODE (x18) != E_BImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (pattern52 (x3) != 0
              || !const_int_operand (operands[10], E_VOIDmode)
              || pattern55 (x9) != 0)
            return -1;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[2]))
            return -1;
          x27 = XVECEXP (x23, 0, 0);
          if (!rtx_equal_p (x27, operands[4]))
            return -1;
          x28 = XEXP (x24, 0);
          if (!rtx_equal_p (x28, operands[3]))
            return -1;
          x29 = XVECEXP (x25, 0, 0);
          if (!rtx_equal_p (x29, operands[6]))
            return -1;
          x30 = XVECEXP (x21, 0, 2);
          if (!rtx_equal_p (x30, operands[10])
              || !
#line 2435 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(MACFLAGS_MATCH_P (INTVAL (operands[10]), INTVAL (operands[11]))))
            return -1;
          return 123; /* flag_mul_macv2hi_parts_acconly_andcc0 */

        case MEM:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x16 = XEXP (x9, 0);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 35)
            {
              res = recog_14 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (GET_CODE (x16) != MEM)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != UNSPEC
              || XVECLEN (x10, 0) != 4
              || XINT (x10, 1) != 13
              || GET_MODE (x10) != E_SImode)
            return -1;
          x31 = XVECEXP (x10, 0, 0);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_SImode)
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x18 = XEXP (x12, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 35
              || GET_MODE (x18) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || pattern48 (x10) != 0)
            return -1;
          x32 = XEXP (x16, 0);
          if (!rtx_equal_p (x32, operands[1]))
            return -1;
          return 260; /* sync_compare_and_swapsi_internal */

        default:
          return -1;
        }

    case CALL:
      switch (pattern7 (x1))
        {
        case 0:
          x12 = XVECEXP (x1, 0, 2);
          switch (pattern36 (x12, pnum_clobbers))
            {
            case 0:
              if (!
#line 2103 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              *pnum_clobbers = 1;
              return 100; /* *call_symbol_fdpic */

            case 1:
              if (!
#line 2202 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
                return -1;
              return 108; /* *call_symbol */

            case 2:
              if (!
#line 2215 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
                return -1;
              return 109; /* *sibcall_symbol */

            default:
              return -1;
            }

        case 1:
          x12 = XVECEXP (x1, 0, 2);
          switch (pattern36 (x12, pnum_clobbers))
            {
            case 0:
              if (!
#line 2157 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              *pnum_clobbers = 1;
              return 104; /* *call_insn_fdpic */

            case 1:
              if (!
#line 2256 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              return 112; /* *call_insn */

            case 2:
              if (!
#line 2266 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                return -1;
              return 113; /* *sibcall_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!general_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_CODE (operands[0]))
        {
        case SYMBOL_REF:
          if (!symbol_ref_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          switch (pattern43 (x10))
            {
            case 0:
              if (!
#line 2103 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              return 100; /* *call_symbol_fdpic */

            case 1:
              if (!
#line 2116 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              return 101; /* *sibcall_symbol_fdpic */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!register_no_elim_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          switch (pattern43 (x10))
            {
            case 0:
              if (!
#line 2157 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              return 104; /* *call_insn_fdpic */

            case 1:
              if (!
#line 2168 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                return -1;
              return 105; /* *sibcall_insn_fdpic */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CALL:
          x11 = XEXP (x7, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != USE)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          x13 = XEXP (x7, 1);
          operands[2] = x13;
          if (!general_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          switch (GET_CODE (operands[1]))
            {
            case SYMBOL_REF:
              if (!symbol_ref_operand (operands[1], E_SImode))
                return -1;
              x10 = XVECEXP (x1, 0, 3);
              switch (pattern43 (x10))
                {
                case 0:
                  if (!
#line 2130 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  return 102; /* *call_value_symbol_fdpic */

                case 1:
                  if (!
#line 2144 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  return 103; /* *sibcall_value_symbol_fdpic */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!register_no_elim_operand (operands[1], E_SImode))
                return -1;
              x10 = XVECEXP (x1, 0, 3);
              switch (pattern43 (x10))
                {
                case 0:
                  if (!
#line 2180 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  return 106; /* *call_value_insn_fdpic */

                case 1:
                  if (!
#line 2192 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 107; /* *sibcall_value_insn_fdpic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL
              || pattern16 (x1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          if (GET_MODE (x9) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != USE
              || pattern51 (x1) != 0)
            return -1;
          switch (pattern54 (x1))
            {
            case 0:
              *pnum_clobbers = 4;
              return 116; /* rep_movsi */

            case 1:
              *pnum_clobbers = 4;
              return 117; /* rep_movhi */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x7) != 35
              || GET_MODE (x7) != E_SImode)
            return -1;
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != PLUS
              || GET_MODE (x6) != E_SImode)
            return -1;
          x14 = XEXP (x6, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 14
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x6, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x16 = XEXP (x4, 1);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 15
              || GET_MODE (x16) != E_SImode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode)
            return -1;
          x17 = XEXP (x8, 0);
          if (GET_CODE (x17) != PLUS
              || GET_MODE (x17) != E_SImode)
            return -1;
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 14
              || GET_MODE (x18) != E_SImode)
            return -1;
          x19 = XEXP (x17, 1);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x20 = XEXP (x5, 1);
          if (GET_CODE (x20) != PLUS
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 14
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x20, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != SET)
            return -1;
          x23 = XEXP (x10, 1);
          if (GET_CODE (x23) != PLUS
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XEXP (x23, 0);
          if (GET_CODE (x24) != REG
              || REGNO (x24) != 14
              || GET_MODE (x24) != E_SImode)
            return -1;
          x25 = XEXP (x10, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 14
              || GET_MODE (x25) != E_SImode)
            return -1;
          x26 = XEXP (x23, 1);
          operands[0] = x26;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          return 138; /* link */

        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 13
              || GET_MODE (x7) != E_SImode
              || pattern29 (x1) != 0)
            return -1;
          x27 = XVECEXP (x7, 0, 0);
          if (GET_MODE (x27) != E_SImode)
            return -1;
          x28 = XVECEXP (x7, 0, 1);
          if (!register_no_elim_operand (x28, E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          switch (GET_CODE (x27))
            {
            case PLUS:
              switch (pattern46 (x1, PLUS))
                {
                case 0:
                  return 245; /* sync_addsi_internal */

                case 1:
                  return 255; /* sync_new_addsi_internal */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern46 (x1, MINUS))
                {
                case 0:
                  return 246; /* sync_subsi_internal */

                case 1:
                  return 256; /* sync_new_subsi_internal */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern46 (x1, IOR))
                {
                case 0:
                  return 247; /* sync_iorsi_internal */

                case 1:
                  return 257; /* sync_new_iorsi_internal */

                default:
                  return -1;
                }

            case AND:
              switch (pattern46 (x1, AND))
                {
                case 0:
                  return 248; /* sync_andsi_internal */

                case 1:
                  return 258; /* sync_new_andsi_internal */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern46 (x1, XOR))
                {
                case 0:
                  return 249; /* sync_xorsi_internal */

                case 1:
                  return 259; /* sync_new_xorsi_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MEM:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x16 = XEXP (x4, 1);
          if (GET_CODE (x16) != UNSPEC
              || pattern30 (x4) != 0
              || pattern29 (x1) != 0)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x29 = XVECEXP (x16, 0, 0);
          if (GET_MODE (x29) != E_SImode)
            return -1;
          x30 = XVECEXP (x16, 0, 1);
          operands[3] = x30;
          if (!register_no_elim_operand (operands[3], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x17 = XEXP (x8, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_CODE (x29))
            {
            case PLUS:
              if (pattern49 (x29) != 0)
                return -1;
              return 250; /* sync_old_addsi_internal */

            case MINUS:
              if (pattern49 (x29) != 0)
                return -1;
              return 251; /* sync_old_subsi_internal */

            case IOR:
              if (pattern49 (x29) != 0)
                return -1;
              return 252; /* sync_old_iorsi_internal */

            case AND:
              if (pattern49 (x29) != 0)
                return -1;
              return 253; /* sync_old_andsi_internal */

            case XOR:
              if (pattern49 (x29) != 0)
                return -1;
              return 254; /* sync_old_xorsi_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || pattern16 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 45
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 47
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 49
      || GET_MODE (x13) != E_SImode
      || pattern51 (x1) != 0)
    return -1;
  x14 = XEXP (x7, 0);
  operands[5] = x14;
  if (!scratch_operand (operands[5], E_HImode))
    return -1;
  switch (pattern54 (x1))
    {
    case 0:
      return 116; /* rep_movsi */

    case 1:
      return 117; /* rep_movhi */

    default:
      return -1;
    }
}

static int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      return recog_8 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_6 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_9 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          if (!immediate_operand (operands[2], E_SImode)
              || !
#line 478 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
            return -1;
          return 9; /* movsi_low */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 3
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          return 11; /* movsi_low_pic */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_PDImode:
              if (!register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 15; /* load_accumulator */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nonimmediate_operand (operands[1], E_HImode))
                    return -1;
                  return 28; /* extendhisi2 */

                case E_QImode:
                  if (!nonimmediate_operand (operands[1], E_QImode))
                    return -1;
                  return 32; /* extendqisi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 31; /* extendqihi2 */

            case E_DImode:
              switch (pattern18 (x2))
                {
                case 0:
                  return 37; /* extendsidi2 */

                case 1:
                  return 38; /* extendqidi2 */

                case 2:
                  return 39; /* extendhidi2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (pattern8 (x2) != 0)
            return -1;
          return 16; /* load_accumulator_pair */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_4 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              return 29; /* zero_extendhisi2 */

            case E_BImode:
              if (!nonimmediate_operand (operands[1], E_BImode))
                return -1;
              return 30; /* zero_extendbisi2 */

            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 34; /* zero_extendqisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 33; /* zero_extendqihi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 35; /* zero_extendqidi2 */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 36; /* zero_extendhidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!pos_scale_operand (operands[3], E_SImode))
            return -1;
          return 42; /* *bfin.md:1144 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 81; /* *ashlsi3_insn */

        default:
          return -1;
        }

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case MULT:
              if (pattern19 (x2) != 0
                  || !scale_by_operand (operands[3], E_SImode))
                return -1;
              return 43; /* *bfin.md:1153 */

            case ASHIFT:
              if (pattern19 (x2) != 0
                  || !pos_scale_operand (operands[3], E_SImode))
                return -1;
              return 44; /* *bfin.md:1162 */

            case CONST_INT:
            case REG:
            case SUBREG:
              switch (pattern17 (x2))
                {
                case 0:
                  if (!reg_or_7bit_operand (operands[2], E_SImode))
                    return -1;
                  return 50; /* addsi3 */

                case 1:
                  return 162; /* addv2hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
          if (pattern9 (x2) != 0
              || !scale_by_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 45; /* *bfin.md:1171 */

        case ASHIFT:
          if (pattern9 (x2) != 0
              || !pos_scale_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 46; /* *bfin.md:1180 */

        case VEC_SELECT:
          switch (pattern11 (x2))
            {
            case 0:
              return 174; /* addlohiv2hi3 */

            case 1:
              return 175; /* addhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      return recog_5 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern5 (x2, E_SImode) != 0)
                return -1;
              return 51; /* ssaddsi3 */

            case E_PDImode:
              if (!register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode
                  || !register_operand (operands[1], E_PDImode)
                  || !nonmemory_operand (operands[2], E_PDImode))
                return -1;
              return 54; /* addpdi3 */

            case E_HImode:
              if (pattern5 (x2, E_HImode) != 0)
                return -1;
              return 154; /* ssaddhi3 */

            case E_V2HImode:
              if (pattern5 (x2, E_V2HImode) != 0)
                return -1;
              return 163; /* ssaddv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern12 (x4) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x9 = XVECEXP (x8, 0, 0);
          operands[3] = x9;
          if (pattern32 (x2) == 0)
            return 156; /* ssaddhi3_parts */
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          switch (pattern10 (x2))
            {
            case 0:
              return 176; /* ssaddlohiv2hi3 */

            case 1:
              return 177; /* ssaddhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern17 (x2))
            {
            case 0:
              if (!reg_or_neg7bit_operand (operands[2], E_SImode))
                return -1;
              return 52; /* subsi3 */

            case 1:
              return 164; /* subv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern11 (x2))
            {
            case 0:
              return 170; /* sublohiv2hi3 */

            case 1:
              return 171; /* subhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern6 (x2))
            {
            case 0:
              return 53; /* sssubsi3 */

            case 1:
              return 155; /* sssubhi3 */

            case 2:
              return 165; /* sssubv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern12 (x4) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x9 = XVECEXP (x8, 0, 0);
          operands[3] = x9;
          if (pattern32 (x2) == 0)
            return 157; /* sssubhi3_parts */
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          switch (pattern10 (x2))
            {
            case 0:
              return 172; /* sssublohiv2hi3 */

            case 1:
              return 173; /* sssubhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_PDImode))
        return -1;
      return 56; /* us_truncpdisi2 */

    case EQ:
      if (GET_MODE (x2) != E_BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_BImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          return 57; /* *not_bittst */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (reg_or_const_int_operand (operands[2], E_SImode))
                return 118; /* compare_eq */
            }
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 132; /* notbi */

        default:
          return -1;
        }

    case NE:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_BImode)
              || GET_MODE (x2) != E_BImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          return 58; /* *bittst */

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              if (!register_operand (operands[0], E_BImode)
                  || GET_MODE (x2) != E_BImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 130; /* movsibi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_BImode))
                return -1;
              return 131; /* movbisi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 59; /* *bit_extract */

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* *not_bit_extract */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!rhs_andsi3_operand (operands[2], E_SImode))
        return -1;
      return 61; /* *andsi_insn */

    case XOR:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!regorlog2_operand (operands[2], E_SImode))
        return -1;
      return 63; /* xorsi3 */

    case TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case POPCOUNT:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 64; /* ones */

        case CLRSB:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 72; /* signbitssi2 */

        case LSHIFTRT:
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != SS_PLUS
              || GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 1);
          if (GET_CODE (x12) != CONST_INT
              || XWINT (x12, 0) != 32768L)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 73; /* ssroundsi2 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern6 (x2))
        {
        case 0:
          return 65; /* smaxsi3 */

        case 1:
          return 74; /* smaxhi3 */

        case 2:
          return 179; /* smaxv2hi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern6 (x2))
        {
        case 0:
          return 66; /* sminsi3 */

        case 1:
          return 75; /* sminhi3 */

        case 2:
          return 178; /* sminv2hi3 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern0 (x1))
        {
        case 0:
          return 67; /* abssi2 */

        case 1:
          return 76; /* abshi2 */

        default:
          return -1;
        }

    case SS_ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 68; /* ssabssi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode))
            return -1;
          return 238; /* ssabsv2hi2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern0 (x1))
        {
        case 0:
          return 69; /* negsi2 */

        case 1:
          return 77; /* neghi2 */

        default:
          return -1;
        }

    case SS_NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 70; /* ssnegsi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 78; /* ssneghi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode))
            return -1;
          return 237; /* ssnegv2hi2 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 71; /* one_cmplsi2 */

    case CLRSB:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 79; /* clrsbhi2 */

    case ASHIFTRT:
      switch (pattern1 (x1))
        {
        case 0:
          return 82; /* ashrsi3 */

        case 1:
          return 88; /* ashrpdi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 83; /* rotl16 */

    case LSHIFTRT:
      switch (pattern1 (x1))
        {
        case 0:
          return 86; /* lshrsi3 */

        case 1:
          return 87; /* lshrpdi3 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pattern2 (x2) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x14 = XVECEXP (x2, 0, 0);
      x15 = XEXP (x14, 0);
      operands[1] = x15;
      if (!address_operand (operands[1], E_SImode))
        return -1;
      return 99; /* load_funcdescsi */

    case LT:
      if (pattern3 (x1) != 0)
        return -1;
      return 119; /* compare_lt */

    case LE:
      if (pattern3 (x1) != 0)
        return -1;
      return 120; /* compare_le */

    case LEU:
      if (pattern3 (x1) != 0)
        return -1;
      return 121; /* compare_leu */

    case LTU:
      if (pattern3 (x1) != 0)
        return -1;
      return 122; /* compare_ltu */

    case VEC_CONCAT:
      return recog_7 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      if (!const01_operand (operands[2], E_VOIDmode))
        return -1;
      return 153; /* movv2hi_hi */

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_18 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[0] = x1;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 5
              || !push_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          return 140; /* push_multiple */

        case SET:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode
              || pattern26 (x2, 14) != 0
              || !pop_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          return 141; /* pop_multiple */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 127; /* nop */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x1, 1))
        {
        case 12:
          return 128; /* forced_nop */

        case 11:
          return 129; /* mnop */

        default:
          return -1;
        }

    case EH_RETURN:
      return 137; /* eh_return_internal */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          if (XINT (x1, 1) != 5)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VOIDmode))
            return -1;
          return 143; /* dummy_load */

        case 1:
          switch (XINT (x1, 1))
            {
            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 144; /* stall */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 145; /* csync */

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 146; /* ssync */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x7 = XEXP (x1, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XEXP (x1, 0);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          return 147; /* trap */

        case REG:
          if (REGNO (x8) != 34
              || GET_MODE (x8) != E_BImode)
            return -1;
          return 148; /* trapifcc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && general_operand (operands[1], E_DImode)
                  && 
#line 509 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_1 (insn, operands);
              break;

            case E_SImode:
              if (d_register_operand (operands[0], E_SImode)
                  && d_register_operand (operands[1], E_SImode)
                  && 
#line 642 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(splitting_for_sched && !optimize_size))
                return gen_split_4 (insn, operands);
              break;

            case E_V2HImode:
              if (nonimmediate_operand (operands[0], E_V2HImode)
                  && general_operand (operands[1], E_V2HImode)
                  && 
#line 655 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed && GET_CODE (operands[1]) == CONST_VECTOR))
                return gen_split_5 (insn, operands);
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && general_operand (operands[1], E_DFmode)
                  && 
#line 721 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_6 (insn, operands);
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && immediate_operand (operands[1], E_SFmode)
                  && 
#line 847 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_8 (insn, operands);
              break;

            default:
              break;
            }
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && d_register_operand (operands[0], E_SImode)
              && 
#line 636 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(splitting_for_sched && !optimize_size))
            return gen_split_3 (insn, operands);
          operands[1] = x3;
          if (!symbolic_or_const_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 828 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed
   /* Always split symbolic operands; split integer constants that are
      too large for a single instruction.  */
   && (GET_CODE (operands[1]) != CONST_INT
       || (INTVAL (operands[1]) < -32768
 	   || INTVAL (operands[1]) >= 65536
	   || (INTVAL (operands[1]) >= 32768 && PREG_P (operands[0]))))))
            return NULL;
          return gen_split_7 (insn, operands);

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case VEC_CONCAT:
              if (pattern8 (x3) != 0
                  || !
#line 576 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                return NULL;
              return gen_split_2 (insn, operands);

            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !nonimmediate_operand (operands[1], E_HImode)
                      || !
#line 890 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed && bfin_dsp_memref_p (operands[1])))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case E_DImode:
                  switch (pattern18 (x3))
                    {
                    case 0:
                      if (!
#line 1014 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_11 (insn, operands);

                    case 1:
                      if (!
#line 1028 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_12 (insn, operands);

                    case 2:
                      if (!
#line 1041 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_13 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !
#line 905 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed && bfin_dsp_memref_p (operands[1])))
            return NULL;
          return gen_split_10 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 1683 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(PREG_P (operands[0]) && INTVAL (operands[2]) > 2))
            return NULL;
          return gen_split_16 (insn, operands);

        case UNSPEC_VOLATILE:
          if (pattern2 (x3) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XVECEXP (x3, 0, 0);
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!address_operand (operands[1], E_SImode)
              || !
#line 2050 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        case NE:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_BImode))
            return NULL;
          return gen_split_19 (insn, operands);

        case VEC_CONCAT:
          if (GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[0], E_V2HImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_HImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_HImode)
              || !
#line 2848 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x8 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x8) != SET)
            return NULL;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != ZERO_EXTRACT)
            return NULL;
          switch (pattern14 (x1))
            {
            case 0:
              return gen_split_14 (insn, operands);

            case 1:
              return gen_split_15 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          if (pattern4 (x1) != 0)
            return NULL;
          x8 = XVECEXP (x1, 0, 0);
          x9 = XEXP (x8, 1);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!nondp_reg_or_memory_operand (operands[0], E_SImode))
            return NULL;
          x12 = XEXP (x9, 1);
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          x14 = XVECEXP (x1, 0, 3);
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!scratch_operand (operands[2], E_SImode))
            return NULL;
          x16 = XVECEXP (x1, 0, 1);
          x17 = XEXP (x16, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return NULL;
          x19 = XEXP (x16, 0);
          if (!rtx_equal_p (x19, operands[0])
              || !
#line 2005 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(memory_operand (operands[0], SImode) || splitting_loops))
            return NULL;
          return gen_split_17 (insn, operands);

        default:
          return NULL;
        }

    case EH_RETURN:
      if (!
#line 2697 "../../gcc-14.2.1-20240912/gcc/config/bfin/bfin.md"
(epilogue_completed))
        return NULL;
      return gen_split_20 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
